concurrent_hash_map.h File Reference
`#include "internal/_warning_suppress_enable_notice.h"`
`#include "tbb_stddef.h"`
`#include <iterator>`
`#include <utility>`
`#include <cstring>`
`#include "tbb_allocator.h"`
`#include "spin_rw_mutex.h"`
`#include "atomic.h"`
`#include "tbb_exception.h"`
`#include "tbb_profiling.h"`
`#include "aligned_space.h"`
`#include "internal/_tbb_hash_compare_impl.h"`
`#include "internal/_template_helpers.h"`
`#include "internal/_allocator_traits.h"`
`#include <initializer_list>`
`#include <tuple>`
`#include "internal/_warning_suppress_disable_notice.h"`
Include dependency graph for concurrent_hash_map.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes

struct | tbb::interface5::internal::hash_map_node_base
| Node base type. More...
class | tbb::interface5::internal::hash_map_base
| base class of concurrent_hash_map More...
struct | tbb::interface5::internal::hash_map_base::bucket
| Bucket type. More...
struct | tbb::interface5::internal::hash_map_base::enable_segment_failsafe
| Exception safety helper. More...
class | tbb::interface5::internal::hash_map_iterator< Container, Value >
| Meets requirements of a forward iterator for STL *‍/. More...
class | tbb::interface5::internal::hash_map_range< Iterator >
| Range class used with concurrent_hash_map. More...
class | tbb::interface5::concurrent_hash_map< Key, T, HashCompare, Allocator >
| Unordered map from Key to T. More...
class | tbb::interface5::concurrent_hash_map< Key, T, HashCompare, Allocator >::node
struct | tbb::interface5::concurrent_hash_map< Key, T, HashCompare, Allocator >::node_scoped_guard
class | tbb::interface5::concurrent_hash_map< Key, T, HashCompare, Allocator >::bucket_accessor
| bucket accessor is to find, rehash, acquire a lock, and access a bucket More...
struct | tbb::interface5::concurrent_hash_map< Key, T, HashCompare, Allocator >::call_clear_on_leave
class | tbb::interface5::concurrent_hash_map< Key, T, HashCompare, Allocator >::const_accessor
| Combines data access, locking, and garbage collection. More...
class | tbb::interface5::concurrent_hash_map< Key, T, HashCompare, Allocator >::accessor
| Allows write access to elements and combines data access, locking, and garbage collection. More...
struct | tbb::interface5::concurrent_hash_map< Key, T, HashCompare, Allocator >::accessor_not_used

## Namespaces

| tbb
| The graph class.
| tbb::interface5
| tbb::interface5::internal

## Macros

#define | __TBB_concurrent_hash_map_H_include_area

## Typedefs

typedef size_t | tbb::interface5::internal::hashcode_t
| Type of a hash code. More...

## Functions

template<typename Container , typename T , typename U >
bool | tbb::interface5::internal::operator== (const hash_map_iterator< Container, T > &i, const hash_map_iterator< Container, U > &j)
template<typename Container , typename T , typename U >
bool | tbb::interface5::internal::operator!= (const hash_map_iterator< Container, T > &i, const hash_map_iterator< Container, U > &j)
template<typename Key , typename T , typename HashCompare , typename A1 , typename A2 >
bool | tbb::operator== (const concurrent_hash_map< Key, T, HashCompare, A1 > &a, const concurrent_hash_map< Key, T, HashCompare, A2 > &b)
template<typename Key , typename T , typename HashCompare , typename A1 , typename A2 >
bool | tbb::operator!= (const concurrent_hash_map< Key, T, HashCompare, A1 > &a, const concurrent_hash_map< Key, T, HashCompare, A2 > &b)
template<typename Key , typename T , typename HashCompare , typename A >
void | tbb::swap (concurrent_hash_map< Key, T, HashCompare, A > &a, concurrent_hash_map< Key, T, HashCompare, A > &b)

## Variables

static hash_map_node_base *const | tbb::interface5::internal::rehash_req = reinterpret_cast<hash_map_node_base*>(size_t(3))
| Incompleteness flag value. More...
static hash_map_node_base *const | tbb::interface5::internal::empty_rehashed = reinterpret_cast<hash_map_node_base*>(size_t(0))
| Rehashed empty bucket flag. More...

## Macro Definition Documentation

## __TBB_concurrent_hash_map_H_include_area

#define __TBB_concurrent_hash_map_H_include_area

Definition at line 20 of file concurrent_hash_map.h.

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.